# -*- coding: utf-8 -*-

#Load models, textures, sounds, and code.
from direct.showbase.Loader import Loader

from direct.showbase.DirectObject import DirectObject

from direct.gui.OnscreenText import OnscreenText

# para cargar imagenes
from direct.gui.OnscreenImage import OnscreenImage

from pandac.PandaModules import TextNode

from pandac.PandaModules import NodePath

# This next one enable the transparency and is easily overlooked
from pandac.PandaModules import TransparencyAttrib 
from pandac.PandaModules import TextureStage
from pandac.PandaModules import TexGenAttrib
from pandac.PandaModules import Texture

from pandac.PandaModules import CollisionTraverser
from pandac.PandaModules import CollisionHandlerEvent
from pandac.PandaModules import CollisionNode
from pandac.PandaModules import CollisionSphere
from pandac.PandaModules import CollisionTube
from pandac.PandaModules import CollisionSegment
from pandac.PandaModules import CollisionPlane
from pandac.PandaModules import BitMask32

from pandac.PandaModules import Plane
from pandac.PandaModules import VBase3
from pandac.PandaModules import Point3
from pandac.PandaModules import Vec3

from direct.task.Task import Task

from random import randint,shuffle
from math import hypot,atan,degrees,radians,sin,cos
import re

from escalas import Escalas
        
# FLECHA DE DIRECCION EN PANTALLA
#class Brujula:
#    
#    def __init__(self,nodo,pos):
#        
#        self.brujula = OnscreenImage(image="imagenes/brujula.png",parent=nodo)
#        self.brujula.reparentTo(nodo)
#        self.brujula.setScale(0.2)
#       
#        self.brujula.setPos(pos[0],0,pos[1])
#        
#        self.brujula.setTransparency(TransparencyAttrib.MAlpha)
#        self.brujula.setColor(1,1,1,0.7)
#    
#    def setRoll(self,r):
#        self.brujula.setR(r-90)
#        
#    def __del__(self):
#        self.brujula.removeNode()
#    

# FLECHA DE DIRECCION EN PANTALLA
class FlechaMini:
    
    def __init__(self,nodo):
        
        self.flecha = OnscreenImage(image="imagenes/flecha_verde.png",parent=nodo)
        self.flecha.reparentTo(nodo)
        self.flecha.setScale(0.045)
       
        self.flecha.setPos(VBase3(-0.85,0,0.95))
        
        self.flecha.setTransparency(TransparencyAttrib.MAlpha)
        #self.flecha.setColor(1,1,1,0.7)
 
    def CalcularHeading(self,pos1,pos2,pos3):
        
        vx = pos2[0] - pos1[0]
        vy = pos2[1] - pos1[1]
        
        if(vx == 0):
            anguloDegrees = 90
            #self.setHeading(90)
        elif(vy == 0):
            anguloDegrees = 0
            #self.setHeading(0)
        else:
            angulo = abs( vy / vx ) 
            anguloRad = atan(angulo)
            anguloDegrees = degrees(anguloRad)
        # el calculo de los angulos se puede trasladar a cuando
        # a cuando se direge a su nuevo destino
        if vx<0 and vy>0: # segundo cuadrante
            anguloDegrees = 180 - anguloDegrees
        elif vx<0 and vy<0: # tercer cuadrante
            anguloDegrees = anguloDegrees + 180
        elif vx>0 and vy<0: # cuarto cuadrante
            anguloDegrees = anguloDegrees * (-1)
        
        alpha = anguloDegrees
        
        vx = pos3[0] - pos2[0]
        vy = pos3[1] - pos2[1]
        
        if(vx == 0):
            anguloDegrees = 90
            #self.setHeading(90)
        elif(vy == 0):
            anguloDegrees = 0
            #self.setHeading(0)
        else:
            angulo = abs( vy / vx ) 
            anguloRad = atan(angulo)
            anguloDegrees = degrees(anguloRad)
        # el calculo de los angulos se puede trasladar a cuando
        # a cuando se direge a su nuevo destino
        if vx<0 and vy>0: # segundo cuadrante
            anguloDegrees = 180 - anguloDegrees
        elif vx<0 and vy<0: # tercer cuadrante
            anguloDegrees = anguloDegrees + 180
        elif vx>0 and vy<0: # cuarto cuadrante
            anguloDegrees = anguloDegrees * (-1)
        
        beta = anguloDegrees
        
        self.flecha.setR(360-(beta-alpha))
    
    def setRoll(self,r):
        self.flecha.setR(360-r)
        
    def __del__(self):
        self.flecha.removeNode()


# FLECHA DE DIRECCION SOBRE EL SUELO     
class Flecha:
    
    def __init__(self,nodo):
        
        self.flecha = OnscreenImage(image="imagenes/flecha_verde.png",parent=nodo)
        self.flecha.reparentTo(nodo)
        self.flecha.setScale(Escalas['m-px']*1.5)
        self.flecha.setHpr(0,-90,0)
        
        self.flecha.setTransparency(TransparencyAttrib.MAlpha)
        self.flecha.setColor(1,1,1,0.8)
        
        prioridad = 110
        self.flecha.setBin("fixed", prioridad)
      
        # nodo hacia el que se orienta la flecha
        self.destino = NodePath('nodo_destino')
      
    def setPos(self,pos):
        self.flecha.setX(pos[0])
        self.flecha.setY(pos[1])
    
    # recoloca el nodo hace el que se dirige  el vehiculo 
    def setDestino(self,pos):
        self.destino.setPos(pos) 
    
    # reorienta la flecha
    def Orientar(self):
        self.flecha.lookAt(self.destino)
        self.flecha.setP(-90)
    
    def CalcularHeading(self,pos1,pos2):
        
        vx = pos2[0] - pos1[0]
        vy = pos2[1] - pos1[1]
        
        if(vx == 0):
            anguloDegrees = 90
            #self.setHeading(90)
        elif(vy == 0):
            anguloDegrees = 0
            #self.setHeading(0)
        else:
            angulo = abs( vy / vx ) 
            anguloRad = atan(angulo)
            anguloDegrees = degrees(anguloRad)
        # el calculo de los angulos se puede trasladar a cuando
        # a cuando se direge a su nuevo destino
        if vx<0 and vy>0: # segundo cuadrante
            anguloDegrees = 180 - anguloDegrees
        elif vx<0 and vy<0: # tercer cuadrante
            anguloDegrees = anguloDegrees + 180
        elif vx>0 and vy<0: # cuarto cuadrante
            anguloDegrees = anguloDegrees * (-1)
        
        self.flecha.setH(anguloDegrees-90)
    
    def getHeading(self):
        return self.flecha.getH()
        
    def __del__(self):
        self.flecha.removeNode()
     
class Vehiculo:
    
    # @param parent: nodo padre del vehiculo
    # @param incial: nodo de salida inicio del vehiculo
    # @param pos_inicial: posicion de salida del vehiculo
    # @param es_jugador: 1-> Es el vehiculo del jugador, 0-> otro caso
    # @param num: numero identificativo del vehiculo, unico, usado para las colisiones 
    def __init__(self,parent,nodo_inicial,pos_inicial=VBase3(0,0,0),es_jugador=0,num=0):
        
        # carga el modelo del vehiculo
        self.coche = loader.loadModel('modelos/carnsx')
        # escala para ajustarlo a la carretera
        self.coche.setScale(Escalas['m-px']*1.5/3)
        
        """ transparencia del vehiculo
        self.coche.setTransparency(True)
        self.coche.setColor(1,1,1,.5) 
        """
        
        # TEXTURA
        # establece el colo del vehiculo
        if es_jugador == 1:
            textura='modelos/carnsx.png'
        else:
            textura_select = randint(1,3)
            if textura_select == 1:
                textura = 'modelos/carnsx-green.png'
            if textura_select == 2:
                textura = 'modelos/carnsx-blue.png'
            if textura_select == 3:
                textura = 'modelos/carnsx-yellow.png'
        
        # establece la textura(color) del coche
        text = loader.loadTexture(textura)
        self.coche.find('**/body/body').setTexture(text, 1)
        self.coche.find('**/body/polySurface1').setTexture(text, 1)
        self.coche.find('**/body/polySurface2').setTexture(text, 1)
        #self.coche.setTexGen(TextureStage.getDefault(), TexGenAttrib.MWorldNormal)   
        
        # PRIORRIDAD DE RENDERIZADO
        # para que se vea por encima del mapa
        prioridad = 200
        self.coche.setBin("fixed", prioridad)
        self.coche.reparentTo(parent)
                
        # CONFIGURACION INCIAL DEL VEHICULO
        
        # id del nodo desde el que partio el vehiculo
        self.nodo_origen = nodo_inicial
        # id del nodo hacia el cual se dirige el vehiculo
        self.nodo_destino = nodo_inicial
        # id del nodo del sigiente destino
        self.nodo_sig_destino = nodo_inicial
        
        # posicion inicial del mapa
        self.coche.setPos(pos_inicial)
        # posicion VBase3 de destino del vehiculo
        self.destino = pos_inicial
        

        
        # indica si el vehiculo ha llegado a su destino
        self.ha_llegado = True
        
        # indica si el vehiculo ha sido parado
        self.esta_parado = False
        
        # orientacion del vehiculo
        self.headingRad = None
        # el objeto egg esta en angulo  270
        self.setHeading(0)
        #self.CalcularHeading()
        
        # MOVIMIENTO
        
        # velocidad
        self.velocidad = 0
        self.velMax = Escalas['kmh-pxs']*0
        # aceleracion
        self.aceleracion = Escalas['m-px']*4.2
        
        # ELECCION DEL PROXIMO DESTINO
        # solo para el vehiculo del jugador,indide del nodo_sig_destino
        self.num__nsd = 0
        # lista de nodos_Sig_Destino
        self.lista_sg = None
        
        
        # COLISIONES
        self.cNodeEsfera = CollisionNode( 'morro_'+str(num) )
        #self.cNodeEsfera.addSolid( CollisionSphere(0,-2,0.5,1) )
#        self.cNodeEsfera.addSolid(CollisionSphere(0,-2,0.5,1))
        self.cNodeEsfera.addSolid( CollisionSegment(0,-3.1,0.5,0,-3.2,0.5) )
        self.cNodeEsfera.setFromCollideMask(BitMask32(0x02))
        self.cNodeEsfera.setIntoCollideMask(BitMask32(0x10))
        self.cNodePathEsfera = self.coche.attachNewNode(self.cNodeEsfera)
        
        # envuelve todo el el vehiculo
        self.cNodeTubo= CollisionNode( 'tubo_'+str(num) )
        self.cNodeTubo.addSolid( CollisionTube(0, -1.8, 0.5, 0, 1.8, 0.5, 1.2) )
        self.cNodeTubo.setFromCollideMask(BitMask32(0x11))
        self.cNodeTubo.setIntoCollideMask(BitMask32(0x02))
        self.cNodePathTubo = self.coche.attachNewNode(self.cNodeTubo)
        
        # nodo de colision del vehiculo para el destino
        self.cNodeCoche = CollisionNode( 'coche_'+str(num) )
        self.cNodeCoche.addSolid( CollisionSphere(0,-0.5,-1.5,0.8) )
        self.cNodeCoche.setFromCollideMask(BitMask32(0x05))
        self.cNodeCoche.setIntoCollideMask(BitMask32(0x15))
        self.cNodePathCoche = self.coche.attachNewNode(self.cNodeCoche)
#        self.cNodePathCoche.show()
        
        # nodo de colision situado en la posicion de destino
        self.cNodeDestino = CollisionNode( 'destino_'+str(num) )
        self.cNodeDestino.addSolid( CollisionSegment(0,0,-1.4,0,0,-1.6) )
        self.cNodeDestino.setFromCollideMask(BitMask32(0x15))
        self.cNodeDestino.setIntoCollideMask(BitMask32(0x02))
        self.cNodePathDestino = parent.attachNewNode(self.cNodeDestino)
        # este nodepath no esta unido al vehiculo por lo que necesita aplicarle la escala
        self.cNodePathDestino.setScale(Escalas['m-px']*1.5/3)
#        self.cNodePathDestino.show() 
#        self.cNodePathDestino.setPos(pos_inicial)
        
        # vector con los identificadores de los vehiculos con los que ha colisionado
        self.choques = []
        
        # TASK
        self.last = 0
        
    
    # COLISIONES
    
    def addColliderHand(self,collider):
        base.cTrav.addCollider(self.cNodePathEsfera,collider)
        base.cTrav.addCollider(self.cNodePathDestino,collider)
    
    def setCollDestino(self,Eventos,func):
        # el segmento(from) colision con el tubo(into)
        Eventos.accept(self.cNodePathDestino.getName()+'-into-'+self.cNodePathCoche.getName(),func)
  
    def setCollVehiculo(self,Eventos,func1,func2,cNodePath):
        # evento para la colision
        Eventos.accept(self.cNodePathEsfera.getName()+'-into-'+cNodePath.getName(),func1)
        # evento para el fin de colision
        Eventos.accept(self.cNodePathEsfera.getName()+'-out-'+cNodePath.getName(),func2)
    
    # nodo de colision del vehiculo
    def getcNodePath(self):
        return self.cNodePathTubo
    def getcNodeName(self):
        return self.cNodePathTubo.getName()

    def getcNodePathNameFrom(self):
        return self.cNodePathEsfera.getName()

    def setChoque(self,i):
        self.choques.append(i)
    def delChoque(self,i):
        self.choques.remove(i)
    def esta_chocando(self):
        # esta colisionando con otros vehiculos
        if self.choques.__len__() != 0:
            return True
        # NO esta colisionando con otro vehiculos
        else:
            return False
        
    # comprueba si la colision con el vehiculo i ya fue registrada
    def ColisionRegistrada(self,i):
        return self.choques.__contains__(i)    
    
    # nodo de colision del nodoDestino
    def getcNodePathDestino(self):
        return self.cNodePathDestino
    def getcNodeDestinoName(self):
        return self.cNodePathDestino.getName()
    
    # CONTROL DE ESTADO (parar al final de la carretera)
    def EstaParado(self):
        return self.esta_parado
    def Parar(self):
        self.esta_parado = True
    def Reanudar(self):
        self.esta_parado = False    

    # MOVIMIENTO   
    def setVelocidad(self,v):
        self.velocidad = v
    def getVelMax(self):
        return self.velMax    
    def setVelMax(self,v):
        self.velMax = v
    def setAceleracion(self,a):
        self.aceleracion = a
        
    def Acelerar(self,task):
        
        dt = task.time - self.last
    
        if self.velocidad  < 10:
            # acelerar
            self.velocidad = self.velocidad + self.aceleracion * dt
            self.last = task.time
                        
            return Task.cont
        
        else:
            return Task.done
     
    # ORIENTACION
    # calcula la orientacion del vehiculo a partir de 
    # su posicion actual y la posicion de destino
    def CalcularHeading(self):
        
        #vx = float(self.destino[0]) - float(self.coche.getX())
        #vy = float(self.destino[1]) - float(self.coche.getY())
        vxy = self.destino - self.coche.getPos()
        
        if(vxy.getX() == 0):
            anguloDegrees = 90
            #self.setHeading(90)
        elif(vxy.getY() == 0):
            anguloDegrees = 0
            #self.setHeading(0)
        else:
            angulo = abs( vxy.getY() / vxy.getX() ) 
            anguloRad = atan(angulo)
            anguloDegrees = degrees(anguloRad)
        # el calculo de los angulos se puede trasladar a cuando
        # a cuando se direge a su nuevo destino
        if vxy.getX()<0 and vxy.getY()>0: # segundo cuadrante
            anguloDegrees = 180 - anguloDegrees
        elif vxy.getX()<0 and vxy.getY()<0: # tercer cuadrante
            anguloDegrees = anguloDegrees + 180
        elif vxy.getX()>0 and vxy.getY()<0: # cuarto cuadrante
            anguloDegrees = anguloDegrees * (-1)
        
        # almancena el angulo en radianes
        self.headingRad = radians(anguloDegrees)
        self.setHeading(anguloDegrees)
    
    def Orientar(self):
        self.coche.lookAt(self.cNodePathDestino)
        self.coche.setH(self.coche.getH()+180)
    
    def setHeading(self,h):
        # la orientacion inicial es de 270
        # se corrige para que coincida con los 0
        self.coche.setH(h+90)
    def getHeading(self):
        # la orientacion inicial es de 270
        # se corrige para que coincida con los 0
        return self.coche.getH()-90
    
    # POSICION
    def setPos(self,pos):
        self.coche.setFluidPos(pos)
    def getPos(self):
        return self.coche.getPos() 
    def getX(self):
        return self.coche.getX()
    def getY(self):
        return self.coche.getY()
    
    
    # NODOS ORIGEN, DESTINO Y SIG_DESTINO
    # nodo desde el cual partio el vehiculo
    def setNodoOrigen(self,nodo):
        self.nodo_origen = nodo
    def getNodoOrigen(self):
        return self.nodo_origen
    
    # nodo hacia el que se dirige el vehiculo
    def setNodoDestino(self,nodo):
        # almacena el antiguo destino como origen
        self.nodo_origen = self.nodo_destino
        # establece el nuevo nodo de destino
        self.nodo_destino = nodo
    def getNodoDestino(self):
        return self.nodo_destino
    
    # nodo del siguiente salto
    def setNodoSigDestino(self,nodo):
        self.nodo_origen = self.nodo_destino
        self.nodo_destino =  self.nodo_sig_destino
        self.nodo_sig_destino = nodo
    def getNodoSigDestino(self):
        return self.nodo_sig_destino
    
    # POSICION DESTINO
    # posicion (x,y) hacia la que se dirige el vehiculo
    def setPosDestino(self,pos):
        
        self.destino = pos
        # calcula la nueva direccion del vehiculo
        #self.CalcularHeading()
        # el vehiculo no ha llegado a su nuevo destino
        self.ha_llegado = False
        
        # prueba del nodo de colision de destino
        self.cNodePathDestino.setPos(pos)
        
    def getPosDestino(self):
        return self.destino
    
    # MOVIMIENTO
    def Avanzar(self,dt):
        
        if not self.esta_parado:
            
            if self.velocidad < self.velMax: 
                self.velocidad = self.velocidad + self.aceleracion * dt
            elif self.velocidad > self.velMax:
                if self.velocidad < 1:
                    self.velocidad = 0
                else:
                    self.velocidad = self.velocidad - self.aceleracion * dt * 3.5
            
#            if self.velMax < Escalas['kmh-pxs']*40:
#            self.velocidad = self.velocidad + self.aceleracion * dt
#            elif self.velMax 
#            
#            # distancia euclidea entre el vvehiculo y su destino
#            """ 
#            x = self.coche.getX()
#            y = self.coche.getY()
#            vx = self.destino[0]- x
#            vy = self.destino[1]- y
#            lejania = hypot(abs(vx),abs(vy))
#            """
#            
#            """
#            vlejania = self.destino - self.coche.getPos()
#            
#            if vlejania.length()>Escalas['m-px']*0.5:
#                
#                # para evitar el fallo de salida
#                self.CalcularHeading()
#    
#                
#                # calculo del desplazamiento pos cada eje
#                #x = x + (cos(self.headingRad) * self.velocidad ) *dt
#                #y = y + (sin(self.headingRad) * self.velocidad ) *dt
#                
#                #
#                # actualiza la posicion del vehiculo    
#                #self.setPos( (x,y) )
#                #self.coche.setX(x)
#                #self.coche.setY(y)
#                #
#            
#                pos = self.coche.getPos()
#                pos.addX( cos(self.headingRad) * self.velocidad  *dt )
#                pos.addY( sin(self.headingRad) * self.velocidad  *dt )
#                self.coche.setPos(pos)
#                #self.ha_llegado = False
#            
#            else:
#                self.ha_llegado = True
#            """ 
             
            pos = self.coche.getPos()
            pos  = self.destino - pos
            pos.normalize()
            pos = pos * (self.velocidad*dt)
            self.coche.setPos(pos+self.coche.getPos())
            
            
    def HaLlegado(self):
        return self.ha_llegado
        
    def dettach(self):
        self.coche.detachNode()
    def hide(self):
        self.coche.hide()
        # lo aleja del escenario
        self.coche.setPos(0,0,-Escalas['m-px']*10)    
    
    def reparentTo(self,parent):
        self.coche.reparentTo(parent)
       
    def __del__(self):
        #print 'eliminando vehiculo __del__',self.getcNodeName()
        self.coche.removeNode()
        self.cNodePathEsfera.removeNode()
        self.cNodePathTubo.removeNode()
        self.cNodePathDestino.removeNode()
        self.cNodePathCoche.removeNode()
    

class Circulacion():
    
    def __init__(self,nodo,nodo2d):
        
        self.NodoEscenario = nodo
        self.NodoEscenario2d = nodo2d
        
        # nodo de referencia para el arbol de renderizado
        self.NodoCirculacion = NodePath('circulacion')
        self.NodoCirculacion2d = NodePath('circulacion2d')
        
        # EVENTOS
        self.EventosCirculacion = DirectObject()
        
        # FUENTES
        fontSansBold = loader.loadFont('fuentes/FreeSansBold.ttf')
        fontSerif = loader.loadFont('fuentes/FreeSerif.ttf')
        
        """
        # BRUJULA DE ORIENTACION
        self.brujula = Brujula(self.NodoCirculacion2d,(-1.1,-0.7))
        """
        
        # COLISIONES
        # inicializa las colisiones en el loop principal
        base.cTrav = CollisionTraverser()
        #base.cTrav.showCollisions(render)
        # define el manejador de eventos a utilizar
        self.collHandEvent=CollisionHandlerEvent()
        # patrones del manejador de eventos
#        self.collHandEvent.addInPattern('%fn-into')
        self.collHandEvent.addInPattern('%fn-into-%in')
        self.collHandEvent.addOutPattern('%fn-out-%in')
                
        # INSTRUCCIONES
        
        # direccion del vehiculo
        self.texto_direccion = OnscreenText(text='Próximo giro:',
                                       pos=(-1.3,0.93),
                                       fg=(1,1,1,1),
                                       bg=(0,0,0,0.4),
                                       scale = 0.05,
                                       align = TextNode.ALeft,
                                       font = fontSansBold,
                                       parent=self.NodoCirculacion2d)
        
        # indicacion del total de destinos disponibles
        self.texto_destinos = OnscreenText(text='',
                                       pos=(-1.3,0.85),
                                       fg=(1,1,1,1),
                                       bg=(0,0,0,0.4),
                                       scale = 0.05,
                                       align = TextNode.ALeft,
                                       font = fontSansBold,
                                       parent=self.NodoCirculacion2d,
                                       mayChange=True)  
        
        # texto de velocidad
        self.texto_velocidad = OnscreenText(text='',
                                       pos=(-1.3,0.77),
                                       fg=(1,1,1,1),
                                       bg=(0,0,0,0.4),
                                       scale = 0.05,
                                       align = TextNode.ALeft,
                                       font = fontSansBold,
                                       parent=self.NodoCirculacion2d,
                                       mayChange=True)
        
        # texto de direccion/destino actual del jugador
        self.direccion_actual = OnscreenText(text='',
                                       pos=(-1.3,0.69),
                                       fg=(1,1,1,1),
                                       bg=(0,0,0,0.4),
                                       scale = 0.05,
                                       align = TextNode.ALeft,
                                       font = fontSansBold,
                                       parent=self.NodoCirculacion2d,
                                       mayChange=True)
        
        # texto de direccion/destino proximo del jugador
        self.direccion_siguiente = OnscreenText(text='',
                                       pos=(-1.3,0.6105),
                                       fg=(1,1,1,1),
                                       bg=(0,0,0,0.4),
                                       scale = 0.05,
                                       align = TextNode.ALeft,
                                       font = fontSansBold,
                                       parent=self.NodoCirculacion2d,
                                       mayChange=True)
        
        # texto de direccion/destino proximo del jugador
        self.direccion_siguiente_salto = OnscreenText(text='',
                                       pos=(-1.3,0.53),
                                       fg=(1,1,1,1),
                                       bg=(0,0,0,0.4),
                                       scale = 0.05,
                                       align = TextNode.ALeft,
                                       font = fontSansBold,
                                       parent=self.NodoCirculacion2d,
                                       mayChange=True)
        
        # texto para indicar que ha llegado al limite del mapa
        self.limiteMapa = OnscreenText(text='Ha llegado al limite de mapa, pulse \'control-q\' para volver al menú.',
                                       pos=(0,0,0),
                                       fg=(1,1,1,1),
                                       bg=(0,0,0,0.4),
                                       scale = 0.08,
                                       align = TextNode.ACenter,
                                       font = fontSerif,
                                       parent=None)
        self.limiteMapa.detachNode()
        
        # FLECHA DE DIRECCION EN PANTALLA
        self.flecha_mini = FlechaMini(self.NodoCirculacion2d)
        
        # FLECHA DE DIRECCION SOBRE EL SUELO
        self.flecha = Flecha(self.NodoCirculacion)
        
        # CIRCULACION
        # total de vehculos en el escenario
        self.nvehiculos = 25
        
        # vehiculos indexados por numero de cNode
        self.vehiculos = {}
        # vehiculos en espera de ser rehubicados
        self.vehiculos_fuera = []
        
        # MAPA DE VELOCIDADES
        # correspondencia entre la velocidad y la siguiente
        self.velocidades_aumentar = {0:20*Escalas['kmh-pxs'],
                                     20*Escalas['kmh-pxs']:50*Escalas['kmh-pxs'],
                                     50*Escalas['kmh-pxs']:80*Escalas['kmh-pxs'],
                                     80*Escalas['kmh-pxs']:120*Escalas['kmh-pxs'],
                                     120*Escalas['kmh-pxs']:120*Escalas['kmh-pxs']}
        # correspondencia entre la velocidad y la anterior
        self.velocidades_disminuir = {120*Escalas['kmh-pxs']:80*Escalas['kmh-pxs'],
                                      80*Escalas['kmh-pxs']:50*Escalas['kmh-pxs'],
                                      50*Escalas['kmh-pxs']:20*Escalas['kmh-pxs'],
                                      20*Escalas['kmh-pxs']:20*Escalas['kmh-pxs'],
                                      20*Escalas['kmh-pxs']:0,
                                      0:0 }
            
        # varible que activa el cambio de direcion del movimiento del jugador
        self.invRumbo = False    
        
    def Crear(self,map,nodo_inicio=None,nodo_destino=None):
        
        # mapa del escenario
        self.mapa = map
        
        # VEHICULO DEL JUGADOR
        
        nodo_origen = None
        if nodo_inicio != None:
#            for n in nodo_inicio:
#                pos = self.mapa.getNodoPosById( n )
#                if pos.getX() > self.mapa.getBounds().getMinX() and pos.getX() < self.mapa.getBounds().getMaxX():
#                    if pos.getY() > self.mapa.getBounds().getMinY() and pos.getY() > self.mapa.getBounds().getMaxY():
#                        nodo_origen = n
#                    else:
#                        nodo_origen = n
#                else:
#                    nodo_origen = n
            
            nodo_origen = nodo_inicio
            
            #nodo_origen = nodo_inicio
            # determina el nodo de destino inmediato
            if nodo_destino == None:
                nodo_destino = self.CalcularNodoDestino(nodo_origen,nodo_origen)
            # calcula el nodo del siguiente salto
            # el tercer parametro es apra obtener la lista de nodos disponibles
            nodo_sig_destino = self.CalcularNodoDestino(nodo_origen,nodo_destino,'lista')
        
        # no se encontro un nodo de origen valido
        if nodo_origen == None:
            # busca el nodo de inicio adecuado
            # indice del buscador del nodo adecuado
            i = 0
            lista_nodos = self.mapa.getListaNodosMatrizCamino()
            # mientras no exista nodos disponibles en el tercer destino
            nodo_sig_destino = []
            esta_fuera = False
            while nodo_sig_destino.__len__() == 0 or esta_fuera:
                #vehiculo manejado por el jugador
                nodo_origen = lista_nodos[i]
                pos = self.mapa.getNodoPosById( nodo_origen )
                if pos.getX() < self.mapa.getBounds().getMinX():
                    esta_fuera = True
                elif pos.getX() > self.mapa.getBounds().getMaxX():
                    esta_fuera = True 
                elif pos.getY() < self.mapa.getBounds().getMinY():
                    esta_fuera = True
                elif pos.getY() > self.mapa.getBounds().getMaxY():
                    esta_fuera = True
                else:
                    esta_fuera = False
                
                # determina el nodo de destino inmediato
                nodo_destino = self.CalcularNodoDestino(nodo_origen,nodo_origen)
                # calcula el nodo del siguiente salto
                # el tercer parametro es apra obtener la lista de nodos disponibles
                nodo_sig_destino = self.CalcularNodoDestino(nodo_origen,nodo_destino,'lista')
                
                i= i+1    
            
            # para el comienzo automatico calcula la porcion de mapa de inicio, en el comienzo manual se
            # hace desde la clase escenario
            self.mapa.CalcularPorcionMapa(self.mapa.getNodoPosById( nodo_origen ), base.camLens.getFar()*2)
            
            # fin while
        
            
        # la posicion de destino sera el cruce de carriles
        pos1 = self.mapa.getNodoPosById( nodo_origen )
        pos2 = self.mapa.getNodoPosById( nodo_destino )
        pos3 = self.mapa.getNodoPosById( nodo_sig_destino[0] )
        
        # si en ese nodo solo hay camino unico la carretera esta en el centro
        if self.mapa.getOneWayByNodo(nodo_origen) == 'yes':
            pos = pos1
        else:
            # establece como posicion de destino el cruce de carriles
            pos = self.CalcularPosicionesCarriles(pos1, pos2)[0]
        
        # crea el vehiculo del jugador
        self.jugador = Vehiculo(self.NodoCirculacion,
                                nodo_origen,
                                pos,
                                1,
                                0)
        
        # registra el vehiculo en el diccionario
        self.vehiculos[0] = self.jugador
        
        # COLISIONES
        # incluye al vehiculos en el entorno de colision
        self.jugador.addColliderHand(self.collHandEvent)
#        # registra el evento de colision y fin de colision con otro vehiculos
#        self.jugador.setCollVehiculo(self.EventosCirculacion, self.Choque, self.FindeChoque)
        # registra el evento de llegada a destino del vehiculo        
        self.jugador.setCollDestino(self.EventosCirculacion,self.setRumbo)
        
              
        # en este orden por funcionamiento interno
        # establce el tercer salto
        self.jugador.setNodoSigDestino(nodo_sig_destino[0])
        # establce el destino inmediato
        self.jugador.setNodoDestino(nodo_destino)
        
        pos_destino = self.CalcularCruceCarrilesNodos(self.jugador.getNodoOrigen(),
                                                         self.jugador.getNodoDestino(), 
                                                         self.jugador.getNodoSigDestino())
        
        self.jugador.setPosDestino(pos_destino)

        self.jugador.Orientar()
        
        # establece la lista de posibles destinos
        self.jugador.lista_sg = nodo_sig_destino
        self.jugador.num__nsd = 0
        
        # VELOCIDAD
        self.jugador.setVelMax(Escalas['kmh-pxs']*0)
        
        # INSTRUCCIONES DE DIRECCION
        self.direccion_actual.node().setText('Posición actual: '+ self.mapa.getWayNombreByNodo( self.jugador.getNodoOrigen() ))
        self.direccion_siguiente.node().setText('Destino inmediato: '+ self.mapa.getWayNombreByNodo( self.jugador.getNodoDestino() ))        
        self.direccion_siguiente_salto.node().setText('Siguiente destino: '+ self.mapa.getWayNombreByNodo( self.jugador.getNodoSigDestino() ))
        
        # POSICION INICIAL DE LA CAMARA
        pos = self.mapa.getNodoPosById(nodo_origen)
        base.camera.setPos(pos[0],pos[1],Escalas['m-px']*2.5)
        self.ActualizarCamara()
                
        # FLECHA    
        self.flecha.setPos(self.mapa.getNodoPosById(self.jugador.getNodoDestino()))
        self.flecha.setDestino(self.mapa.getNodoPosById(self.jugador.getNodoSigDestino()))
        self.flecha.Orientar()
         
        # FLECHA MINI   
        # recibe las posiciones de los tres nodod del vhiculo
        self.flecha_mini.CalcularHeading(pos1, pos2, pos3)
        
        # calcula las posiciones de partida de la circulacion
        origen = self.jugador.getNodoOrigen()
        distancia = base.camLens.getFar()*2
        circulacion_pos_ini = self.CalcularPosInicioCirculacion(origen,distancia)
        
        if circulacion_pos_ini.__contains__(self.jugador.getNodoOrigen()):
            circulacion_pos_ini.remove(self.jugador.getNodoOrigen())
        if circulacion_pos_ini.__contains__(self.jugador.getNodoDestino()):
            circulacion_pos_ini.remove(self.jugador.getNodoDestino())
        
        #CREACION DE LOS VEHICULOS QUE FORMAN LA CIRCULACION
        # crea los vehiculos de circulacion ordenaria
        i = 1 # contador para nombrar el nodo de colision de cada vehiculo
        for nodo in circulacion_pos_ini:
            
            # controla el numero de vehiculos
            #if randint(0,99)<80 and i<self.nvehiculos and nodo!=self.jugador.getNodoOrigen():
            if i<self.nvehiculos:
                
                pos_inicial = self.mapa.getNodoPosById( nodo )
                v = Vehiculo(self.NodoCirculacion,nodo,pos_inicial,0,str(i))
                
                # determina el nodo de destino inmediato
                nodo_destino = self.CalcularNodoDestino(nodo,nodo)
                # calcula el nodo del siguiente salto
                nodo_sig_destino = self.CalcularNodoDestino(nodo,nodo_destino)
                
                # EN ESTE ORDEN POR FUNCIONAMIENTO DE LOS METODOS
                # establece destino del siguiente salto
                v.setNodoSigDestino( nodo_sig_destino )
                # establece el nodde de destino inmediato
                v.setNodoDestino( nodo_destino )
                
                # COLISIONES
                # incluye al vehiculos en el entorno de colision
                v.addColliderHand(self.collHandEvent)
#                # registra el evento de colision y fin de colision con otro vehiculos
#                v.setCollVehiculo(self.EventosCirculacion, self.Choque, self.FindeChoque)
                # registra el evento de llegada a destino del vehiculo        
                v.setCollDestino(self.EventosCirculacion,self.setRumbo)
                
#                #COLISIONES
#                #base.cTrav.addCollider(v.getcNodePath(),self.collHandEvent)
#                base.cTrav.addCollider(v.getcNodePath(),self.collHandEvent)
#                self.EventosCirculacion.accept(v.getcNodeName()+'-into',self.Choque)
#                self.EventosCirculacion.accept(v.getcNodeName()+'-out',self.FindeChoque)
#                
##                self.accept(v.getcNodeName()+'-into-'+v.getcNodeDestinoName(),self.setRumbo)
#                base.cTrav.addCollider(v.getcNodePathDestino(),self.collHandEvent)
#                self.EventosCirculacion.accept(v.getcNodeDestinoName()+'-into-'+v.getcNodeName(),self.setRumbo)
#        

                # VELOCIDAD
                v.setVelMax(0*Escalas['kmh-pxs'])

                # si existe un nodo de destino siguiente
                if v.getNodoDestino() != v.getNodoSigDestino():
                    
                    # la posicion de destino sera el cruce de carriles
                    pos1 = self.mapa.getNodoPosById( v.getNodoOrigen() )
                    pos2 = self.mapa.getNodoPosById( v.getNodoDestino() )
                    pos3 = self.mapa.getNodoPosById( v.getNodoSigDestino() )
                    
                    
                    # si en ese nodo solo hay camino unico la carretera esta en el centro
                    if self.mapa.getOneWayByNodo(v.getNodoDestino()) == 'yes':
                        pos_origen = pos1
                    else:
                        pos_origen = self.CalcularPosicionesCarriles(pos1, pos2)[0] 
                        
                    pos_destino = self.CalcularCruceCarrilesNodos(v.getNodoOrigen(),
                                                         v.getNodoDestino(), 
                                                         v.getNodoSigDestino())
                    
                    v.setPos(pos_origen)
                    v.setPosDestino(pos_destino)
                    
                    v.Orientar()                              
                    
                    self.vehiculos[i] = v
                    i = i + 1
                    #v.Avanzar(dt)
                    
                # existe un destino inmediato    
                elif v.getNodoOrigen() != v.getNodoDestino():
                    
                    # calcula la posicion de destino como al final del carril
                    pos1 = self.mapa.getNodoPosById( v.getNodoOrigen() )
                    pos2 = self.mapa.getNodoPosById( v.getNodoDestino() )
                    # pos es una tupla con el inicio y final del carril
                    
                    # si en ese nodo solo hay camino unico la carretera esta en el centro
                    if self.mapa.getOneWayByNodo(v.getNodoDestino()) == 'yes':
                        pos_origen = pos1
                        pos_destino = pos2
                        
                    else:
                        pos_origen = self.CalcularPosicionesCarriles(pos1, pos2)[0] 
                        # establece como posicion de destino el cruce de carriles
                        pos_destino = self.CalcularPosicionesCarriles(pos1, pos2)[1]
                        
                    
                    v.setPos(pos_origen)
                    # la posicion de destino es el final del carril
                    v.setPosDestino(pos_destino)
                    v.Orientar()
                
                    self.vehiculos[i] = v
                    i = i + 1
                    #self.vehiculos[i].Avanzar(dt)
                
                # el vehiculo no tiene destino donde ir
                else:
                    self.vehiculos_fuera.append(i)
                    v.setPos(VBase3(0,0,-100))
                    v.Parar()
   
        
        print 'Total de vehiculos en circulacion: ', self.vehiculos.__len__()
        
        # INSTRUCCIONES
        total = str(self.jugador.lista_sg.__len__())
        n = str(self.jugador.num__nsd+1)
        self.texto_destinos.setText('Pulse \'d\' para cambiar el destino. Total: ' + total + ', actual: ' + n)
        
        self.texto_velocidad.setText('Velocidad máxima: ' + str(self.jugador.velMax/Escalas['kmh-pxs']).split('.')[0])

#        brujula eliminada
#        # BRUJULA DE ORIENTACION
#        self.brujula.setRoll(self.jugador.getHeading())        
        
        
        # TASK
        self.gametask = taskMgr.add(self.Movimiento,'movimiento')
        self.gametask.last = 0
        
        # COLISIONES ENTRE VEHICULOS
        for v in self.vehiculos:
            for w in self.vehiculos:
                if v != w:
                    self.vehiculos[v].setCollVehiculo(self.EventosCirculacion,
                                                      self.Choque,
                                                      self.FindeChoque,
                                                      self.vehiculos[w].getcNodePath())
        
        
        # EVENTOS
        self.EventosCirculacion.accept("d",self.CambiarDestino)
        
        self.EventosCirculacion.accept("arrow_up",self.AumentarVelocidad)
        self.EventosCirculacion.accept("arrow_down",self.DisminuirVelocidad)
        
        self.EventosCirculacion.accept("r",self.ActivarInvertirRumbo)
        
        
        # ESCENA
        self.NodoCirculacion.reparentTo(self.NodoEscenario)
        self.NodoCirculacion2d.reparentTo(self.NodoEscenario2d)

    def Eliminar(self):
        
        print 'Circulacion:Eliminar'
        
        # TASK
        taskMgr.remove('movimiento')
        
        # EVENTOS
        self.EventosCirculacion.ignoreAll()
        
        # ELIMINAR VEHICULOS
        
        for v in self.vehiculos.keys():
            self.vehiculos[v].__del__()
            self.vehiculos.pop(v)
            
        # DETACH
        
        # notificacion de final del mapa
        self.limiteMapa.detachNode()
        
        self.NodoCirculacion.detachNode()    
        self.NodoCirculacion2d.detachNode()
        
        # REMOVE
#        self.cNodePathBounds.removeNode()
    
    
    # desactiva los eventos de teclado de la circulacion
    def DesactivarTeclado(self):
        
        self.EventosCirculacion.ignore('arrow_up')
        self.EventosCirculacion.ignore('arrow_down')
        self.EventosCirculacion.ignore('r')
        self.EventosCirculacion.ignore('d')
    
    def ActivarTeclado(self):
        
        self.EventosCirculacion.accept("d",self.CambiarDestino)
        self.EventosCirculacion.accept("arrow_up",self.AumentarVelocidad)
        self.EventosCirculacion.accept("arrow_down",self.DisminuirVelocidad)
        self.EventosCirculacion.accept("r",self.ActivarInvertirRumbo)
    
    """
    detiene la circulacion
    """
    def Parar(self):
    
        self.jugador.Parar()
    
#        taskMgr.remove('movimiento')
    
        # cancela todos los eventos
        self.EventosCirculacion.ignore('d')
        self.EventosCirculacion.ignore('arrow_up')
        self.EventosCirculacion.ignore('arrow_down')
    
    """
    reanuda la circulacion
    """
    def Reanudar(self):
        
        self.jugador.Reanudar()
        
        # TASK
#        self.gametask = taskMgr.add(self.Movimiento,'movimiento')
#        self.gametask.last = 0
        
        # reactiva los eventos de la circulacion
        self.EventosCirculacion.accept("d",self.CambiarDestino)
        self.EventosCirculacion.accept("arrow_up",self.AumentarVelocidad)
        self.EventosCirculacion.accept("arrow_down",self.DisminuirVelocidad)
    
    def NotificarLimiteMapa(self,entry):

        self.limiteMapa.reparentTo(self.NodoCirculacion2d)
        self.jugador.Parar()
#        messenger.send('morro_0-into-bounds',[None])
        
    def CambiarDestino(self):
        
        # SELECCIONA EL SIGUIENTE DESTINO
        # nuevo indice de la lista de destinos
        self.jugador.num__nsd = (self.jugador.num__nsd + 1)%self.jugador.lista_sg.__len__()
        # actualiza el valor del nodo 
        self.jugador.nodo_sig_destino = self.jugador.lista_sg[self.jugador.num__nsd]
        
        # la posicion de destino sera el cruce de carriles
        pos1 = self.mapa.getNodoPosById( self.jugador.getNodoOrigen() )
        pos2 = self.mapa.getNodoPosById( self.jugador.getNodoDestino() )
        pos3 = self.mapa.getNodoPosById( self.jugador.getNodoSigDestino() )
        
        # establece como posicion de destino el cruce de carriles
        pos = cruce = self.CalcularCruceCarrilesNodos(self.jugador.getNodoOrigen(),
                                                         self.jugador.getNodoDestino(), 
                                                         self.jugador.getNodoSigDestino())
        self.jugador.setPosDestino(pos)
        self.jugador.CalcularHeading() 
        
        total = str(self.jugador.lista_sg.__len__())
        n = str(self.jugador.num__nsd+1)
        self.texto_destinos.node().setText('Pulse \'d\' para cambiar el destino. Total: ' + total + ', actual: ' + n)
        
        # actualiza la direccion de la flcha sobre el suelo
        self.flecha.CalcularHeading(pos2,pos3)
        # actualziza la posicion de la brujula en pantalla
        self.flecha_mini.CalcularHeading(pos1, pos2, pos3)
        
        # actualiza la indicacion de proxima direccion
        self.direccion_siguiente_salto.node().setText('Siguiente destino: '+ self.mapa.getWayNombreByNodo( self.jugador.getNodoSigDestino() ))
    
        # desactiva invertir
        self.invRumbo = False
    
    def Choque(self,entry):

        # comprueba que ha colisionado con otro vehiculo
        i = int( entry.getFromNodePath().getName().split('_')[-1] )
#        if True or not re.match("(_[0-9]*)$",entry.getIntoNodePath().getName()):
        
        # las colision se profucen en los dos sentidos, a->b y b->a
        # pero solo se registra una de las dos
        j = int( entry.getIntoNodePath().getName().split('_')[-1])
        if not self.vehiculos[j].ColisionRegistrada(int(i)):
        
            # detiene el vehiculo
            self.vehiculos[i].setVelocidad(0)
            # detien la aceleracion
            self.vehiculos[i].setAceleracion(0)
            
            # registra el vehiculo colisionado
            self.vehiculos[i].setChoque( j )
        
    def FindeChoque(self,entry):
        
        # comprueba que ha colisionado con otro vehiculo
        #if True or not re.match("(_[0-9]*)$",entry.getIntoNodePath().getName()):
            
        # obtiene el identificador del vehiculo que colisiona
        i = int( entry.getFromNodePath().getName().split('_')[-1] )
        # el vehiculo colisionado ua no lo es
        
        # las colision se profucen en los dos sentidos, a->b y b->a
        # pero solo se ha registrado una de las dos
        # solo se elimina una de las dos
        j = int( entry.getIntoNodePath().getName().split('_')[-1] )
        if self.vehiculos[i].ColisionRegistrada(j):
            self.vehiculos[i].delChoque( j )
        
        # si el vehiculo ya no colisiona con ningun vehiculo reanuda la marcha
        if not self.vehiculos[i].esta_chocando():
            self.vehiculos[i].setAceleracion(Escalas['m-px']*4.8)

#     MOVIDO A LA CLASE ESCENARIO
#    def setColisionLimitesMapa(self,bounds,mini_bounds):
#        # colision con el limite del mapa motrado
#        self.EventosCirculacion.accept(self.jugador.cNodePathEsfera.getName()+'-into-mini_bounds',mini_bounds)
#        # colision con el limite del mapa absoluto
#        self.EventosCirculacion.accept(self.jugador.cNodePathEsfera.getName()+'-into-bounds',bounds)
    
    # recibe el nodo origen del vehiculo de referencia
    def CalcularPosInicioCirculacion(self,jugador,distanciaMax,distanciaMin=0):
        
        return self.CalcularPosInicioCirculacion3()

        circulacion_pos_ini = []
        
        # posicion del jugador
        #jugador = self.jugador.getNodoOrigen()
        
        # obtiene los nodos hijo de la posicion de inicio del jugador
        siguientes = self.mapa.getListaNodosSiguientes(jugador)
        anteriores = self.mapa.getListaNodosAnteriores(jugador)
        
        # rango de elementos añadidos
        primero = 0
        ultimo = -1
        
        for i in siguientes:
            if not circulacion_pos_ini.__contains__(i) and i!=jugador:
                dif = (self.mapa.getNodoPosById(i)-self.jugador.getPos() ).length()
                if dif < distanciaMax:
                    circulacion_pos_ini.append(i)
                    
        for i in anteriores:
            if not circulacion_pos_ini.__contains__(i) and i!=jugador:
                dif = (self.mapa.getNodoPosById(i)-self.jugador.getPos() ).length()
                if dif < distanciaMax:
                    circulacion_pos_ini.append(i)
                    
        ultimo = circulacion_pos_ini.__len__()-1
        
        while primero <= ultimo:
             
            # recorre los nodods añadidos en la ultima iteracion
            while primero <= ultimo:
                 
                siguientes = self.mapa.getListaNodosSiguientes( circulacion_pos_ini[primero] )
                anteriores = self.mapa.getListaNodosAnteriores( circulacion_pos_ini[primero] )
                 
                for i in siguientes:
                    if not circulacion_pos_ini.__contains__(i) and i!=jugador:
                        # no es un nodo demasiado lejano
                        dif = (self.mapa.getNodoPosById(i)-self.jugador.getPos() ).length()
                        if dif < distanciaMax:
                            circulacion_pos_ini.append(i)
                            
                for i in anteriores:
                    if not circulacion_pos_ini.__contains__(i) and i!=jugador:
                        dif = (self.mapa.getNodoPosById(i)-self.jugador.getPos() ).length()
                        if dif < distanciaMax:
                            circulacion_pos_ini.append(i)
                
                primero = primero+1
                 
            ultimo = circulacion_pos_ini.__len__()-1
    
        # existe distancia minima
        if distanciaMin !=0 :
            for i in circulacion_pos_ini:
                # si no esta a la distancia minima elimina el nodo
                dif = (self.mapa.getNodoPosById(i)-self.jugador.getPos() ).length()
                if dif < distanciaMin:
                    circulacion_pos_ini.remove(i)
    
        return circulacion_pos_ini
    
    # recibe el nodo origen del vehiculo de referencia
    def CalcularPosInicioCirculacion2(self,jugador,distanciaMax,distanciaMin=0):
        
        circulacion_pos_ini = []
        
        for i in self.mapa.getMatrizCamino().getListaNodos2():     
        
            if not circulacion_pos_ini.__contains__(i) and i!=jugador:
                dif = (self.mapa.getNodoPosById(i)-self.jugador.getPos() ).length()
                if dif < distanciaMax and dif > distanciaMin:
                    circulacion_pos_ini.append(i)
        
        return circulacion_pos_ini
    
    def CalcularPosInicioCirculacion3(self):
        
#        lista = []
#        for i in self.mapa.getPorcionCamino(): 
#            if i != self.jugador.getNodoOrigen():
#                if i != self.jugador.getNodoDestino():
#                    lista.append(i)
#                    
#        return lista

        return self.mapa.getPorcionCamino()
    
    def RehubicarVehiculo(self,v,rescatar=False):
        
        origen = self.jugador.getNodoOrigen()
        
        distanciaMax = base.camLens.getFar()*2
        distanciaMin = base.camLens.getFar()
        circulacion_pos_ini = self.CalcularPosInicioCirculacion(origen,distanciaMax,distanciaMin)
        
        
        
        len = circulacion_pos_ini.__len__()
        if len >10:
                
            nodo = circulacion_pos_ini[ randint(0,len-1) ]
            while nodo == self.jugador.getNodoOrigen() or nodo == self.jugador.getNodoDestino(): 
                nodo = circulacion_pos_ini[ randint(0,len-1) ]
                
            # determina el nodo de destino inmediato
            nodo_destino = self.CalcularNodoDestino(nodo,nodo)
            # calcula el nodo del siguiente salto
            nodo_sig_destino = self.CalcularNodoDestino(nodo,nodo_destino)
            
            # EN ESTE ORDEN POR FUNCIONAMIENTO DE LOS METODOS
            # establece destino del siguiente salto
            self.vehiculos[v].setNodoSigDestino( nodo_sig_destino )
            # establece el nodde de destino inmediato
            self.vehiculos[v].setNodoDestino( nodo_destino )
            # nuevo nodo de origen
            self.vehiculos[v].setNodoOrigen(nodo)
            
            # si existe un nodo de destino siguiente
            if self.vehiculos[v].getNodoDestino() != self.vehiculos[v].getNodoSigDestino():
                
                # la posicion de destino sera el cruce de carriles
                pos1 = self.mapa.getNodoPosById( self.vehiculos[v].getNodoOrigen() )
                pos2 = self.mapa.getNodoPosById( self.vehiculos[v].getNodoDestino() )
                pos3 = self.mapa.getNodoPosById( self.vehiculos[v].getNodoSigDestino() )
                
                # calcula la posicion de partida del vehiculo
                if self.mapa.getOneWayByNodo(self.vehiculos[v].getNodoOrigen()) == 'yes':
                    self.vehiculos[v].setPos(pos1)
                else:
                    pos = self.CalcularPosicionesCarriles(pos1, pos2)
                    self.vehiculos[v].setPos(pos[0])
                
                cruce = self.CalcularCruceCarrilesNodos(self.vehiculos[v].getNodoOrigen(),
                                                         self.vehiculos[v].getNodoDestino(), 
                                                         self.vehiculos[v].getNodoSigDestino())
                self.vehiculos[v].setPosDestino(cruce)
                
                self.vehiculos[v].Orientar()                              
                
                self.vehiculos[v].Reanudar()
                
            # existe un destino inmediato    
            elif self.vehiculos[v].getNodoOrigen() != self.vehiculos[v].getNodoDestino():
                
                
                # calcula la posicion de destino como al final del carril
                pos1 = self.mapa.getNodoPosById( self.vehiculos[v].getNodoOrigen() )
                pos2 = self.mapa.getNodoPosById( self.vehiculos[v].getNodoDestino() )
                # pos es una tupla con el inicio y final del carril
                
                pos = self.CalcularPosicionesCarriles(pos1, pos2)
                
                if self.mapa.getOneWayByNodo(self.vehiculos[v].getNodoOrigen()) == 'yes':
                    self.vehiculos[v].setPos(pos1)
                else:
                    self.vehiculos[v].setPos(pos[0])
                
                if self.mapa.getOneWayByNodo(self.vehiculos[v].getNodoDestino()) == 'yes':
                    self.vehiculos[v].setPosDestino(pos2)
                else:
                    # la posicion de destino es el final del carril
                    self.vehiculos[v].setPosDestino(pos[1])
                    
                self.vehiculos[v].Orientar()
            
                self.vehiculos[v].Reanudar()
            
                #self.vehiculos[i].Avanzar(dt)
        else:
            self.vehiculos_fuera.append(v)
            self.vehiculos[v].setPos(VBase3(0,0,-100))
            self.vehiculos[v].Parar()

        if rescatar == True and self.vehiculos_fuera.__len__()>0:
            self.RehubicarVehiculo( self.vehiculos_fuera[0],True)


    # dado un nodo de partida determina de manera aleatoria
    # el siguiente nodo de destino
    def CalcularNodoDestino(self,nodo_origen,nodo_destino,lista=False):
        
        
        return self.CalcularNodoDestino2(nodo_origen, nodo_destino, lista)
        
        # si no hay nodos de destino disponible
        # se indica devolviendo el nodo de destino
        # que es donde esta actualmente el vehiculo
        nodo_sig_destino = nodo_destino
        # vector con los posibles nodos proximo destino del vehiculo
        lista_destinos = []
        for n in self.mapa.getListaNodosSiguientes(nodo_destino):
            if n != nodo_origen:
                lista_destinos.append(n)
        # pone los nodos en sentido contrario disponible menos
        # el nodo del que partio el vehiculo
        for n in self.mapa.getListaNodosAnteriores(nodo_destino):
            if n != nodo_origen:
                lista_destinos.append(n)
                    
        if lista_destinos.__len__()>0:
            # establce el nuevo nodo de destino
            shuffle(lista_destinos)
            if lista:
                nodo_sig_destino = lista_destinos
            else:        
                nodo_sig_destino = lista_destinos[0]
            
        else:
            if lista:
                lista_destinos.append(nodo_destino)
                nodo_sig_destino = lista_destinos
        
        return nodo_sig_destino
    
    def CalcularNodoDestino2(self,nodo_origen,nodo_destino,lista=False):
            
        listaAdyacentes = []
        
        for nd in self.mapa.getListaAdyacentes(nodo_destino):
            if nd != nodo_origen:
                listaAdyacentes.append(nd)
        
        if listaAdyacentes.__len__()>0:
            if lista:
                return listaAdyacentes
            else:
                shuffle(listaAdyacentes)
                return listaAdyacentes[0]
        else:
            if lista:
                return [nodo_destino]
            else:
                return nodo_destino
        
    
    # recibe las posiciones de los tres nodos que componen
    # los dos tramos de caretera, halla la interseccion de las
    # dos rectas de los dos carriles
    def CalcularCruceCarriles(self,pos1,pos2,pos3):

        #la rectas que marcan los carriles no pasan
        # por le centro de la carretera, hay que calcular
        # el desplazamiento, pos2 y pos3 estan asociados
        # al mimso nodo pero a rectas diferentes
        
        # puntos de referencia para la primera recta        
        tramo1 = self.CalcularPosicionesCarriles(pos1, pos2)
        
        # puntos de referencia para la segunda recta
        tramo2 = self.CalcularPosicionesCarriles(pos2, pos3)
        
        # tupla posicion de inicio del carril
        pos1 = tramo1[0]
        # tupla posicion de final del carril
        pos2 = tramo1[1]
                
        pos3 = tramo2[0] 
        pos4 = tramo2[1]
        
            
        # si los dos primero puntos estan en la misma x
        # calcula para que y pasa por x la segunda recta
        if abs(pos1[0]-pos2[0])<0.001 and abs(pos3[0]-pos4[0])<0.001:
            # al final de su carril
            x = pos2[0]
            y = pos2[1]
            
        elif abs(pos1[0]-pos2[0])<0.001:
            x = pos1[0]
            
            m2 = (pos3[1]-pos4[1])/(pos3[0]-pos4[0])
            b2 = pos3[1] - m2*pos3[0]
            y = m2*x + b2
            
        # si el segundo y tercer punto esta en la misma x
        # calcual para que y para por x la primera recta
        elif abs(pos3[0]-pos4[0])<0.001:
            x = pos3[0]
            
            m1 = (pos1[1]-pos2[1])/(pos1[0]-pos2[0])
            b1 = pos1[1] - m1*pos1[0]
            y = m1*x + b1
            
            
        # en otro caso calcula ambas recta y su punto de corte
        else:
            # m = (y1 - y2)/(x1 - x2)
            m1 = (pos1[1]-pos2[1])/(pos1[0]-pos2[0])
            m2 = (pos3[1]-pos4[1])/(pos3[0]-pos4[0])
            
            if abs(m1-m2)<0.001:
                # las rectar tiene la misma direccion
                # coinciden al final e inicio de carril
                # los dos tramos estan en linea
                x = pos2[0]
                y = pos2[1]
            
            else:
                # b = y - mx
                b1 = pos1[1] - m1*pos1[0]
                b2 = pos3[1] - m2*pos3[0]
                
                x = (b2-b1)/(m1-m2)
            
                y = m1*x + b1
     
        return VBase3(x,y,0)

    def CalcularCruceCarrilesNodos(self,nodo1,nodo2,nodo3):

#        oneway1 = self.mapa.getOneWayByNodo(nodo1)
        oneway2 = self.mapa.getOneWayByNodo(nodo2)
#        oneway3 = self.mapa.getOneWayByNodo(nodo3)
        
        if oneway2 == 'yes':
            return self.mapa.getNodoPosById( nodo2 )

#        print oneway1,oneway2,oneway3
        
        posn1 = self.mapa.getNodoPosById( nodo1 )
        posn2 = self.mapa.getNodoPosById( nodo2 )
        posn3 = self.mapa.getNodoPosById( nodo3 )
        
        #la rectas que marcan los carriles no pasan
        # por le centro de la carretera, hay que calcular
        # el desplazamiento, pos2 y pos3 estan asociados
        # al mimso nodo pero a rectas diferentes
        
#        if oneway1 == 'yes' and oneway2 == 'yes': 
#            tramo1 = self.CalcularPosicionesCarriles(posn1, posn2)
#        # se circula por el carril central
#        else:
#            tramo1 = (posn1,posn2)
#        
#        if oneway2 == 'yes' and oneway3 == 'yes': 
#            # puntos de referencia para la primera recta        
#            tramo2 = self.CalcularPosicionesCarriles(posn2, posn3)
#        # se circula por el carril central
#        else:
#            tramo2 = (posn2,posn3)
#            
        
        tramo1 = self.CalcularPosicionesCarriles(posn1, posn2)
        tramo2 = self.CalcularPosicionesCarriles(posn2, posn3)
        
        
        # tupla posicion de inicio del carril
        pos1 = tramo1[0]
        # tupla posicion de final del carril
        pos2 = tramo1[1]
                
        pos3 = tramo2[0] 
        pos4 = tramo2[1]
        
            
        # si los dos primero puntos estan en la misma x
        # calcula para que y pasa por x la segunda recta
        if abs(pos1[0]-pos2[0])<0.001 and abs(pos3[0]-pos4[0])<0.001:
            # al final de su carril
            x = pos2[0]
            y = pos2[1]
            
        elif abs(pos1[0]-pos2[0])<0.001:
            x = pos1[0]
            
            m2 = (pos3[1]-pos4[1])/(pos3[0]-pos4[0])
            b2 = pos3[1] - m2*pos3[0]
            y = m2*x + b2
            
        # si el segundo y tercer punto esta en la misma x
        # calcual para que y para por x la primera recta
        elif abs(pos3[0]-pos4[0])<0.001:
            x = pos3[0]
            
            m1 = (pos1[1]-pos2[1])/(pos1[0]-pos2[0])
            b1 = pos1[1] - m1*pos1[0]
            y = m1*x + b1
            
            
        # en otro caso calcula ambas recta y su punto de corte
        else:
            # m = (y1 - y2)/(x1 - x2)
            m1 = (pos1[1]-pos2[1])/(pos1[0]-pos2[0])
            m2 = (pos3[1]-pos4[1])/(pos3[0]-pos4[0])
            
            if abs(m1-m2)<0.001:
                # las rectar tiene la misma direccion
                # coinciden al final e inicio de carril
                # los dos tramos estan en linea
                x = pos2[0]
                y = pos2[1]
            
            else:
                # b = y - mx
                b1 = pos1[1] - m1*pos1[0]
                b2 = pos3[1] - m2*pos3[0]
                
                x = (b2-b1)/(m1-m2)
            
                y = m1*x + b1
     
        return VBase3(x,y,0)

    
    # calcula la posicion de partida de cada carril
    # formado para cada par de nodos
    def CalcularPosicionesCarriles(self,pos1,pos2):
        
        # angulo desde pos1 a pos 2
        """
        vx = pos2[0] - pos1[0]
        vy = pos2[1] - pos1[1]
        """
        vxy = pos2 - pos1
        
        if(vxy.getX() == 0):
            anguloDegrees = 90
            #self.setHeading(90)
        elif(vxy.getY() == 0):
            anguloDegrees = 0
            #self.setHeading(0)
        else:
            angulo = abs( vxy.getY() / vxy.getX() ) 
            anguloRad = atan(angulo)
            anguloDegrees = degrees(anguloRad)
        # el calculo de los angulos se puede trasladar a cuando
        # a cuando se direge a su nuevo destino
        if vxy.getX()<=0 and vxy.getY()>0: # segundo cuadrante
            anguloDegrees = 180 - anguloDegrees
        elif vxy.getX()<=0 and vxy.getY()<=0: # tercer cuadrante
            anguloDegrees = anguloDegrees + 180
        elif vxy.getX()>0 and vxy.getY()<=0: # cuarto cuadrante
            anguloDegrees = anguloDegrees * (-1)
        
        # desplazamiento desde pos1
        alpha = anguloDegrees - 90
        betaRadians = radians(alpha)
        
        desplaz_carril = Escalas['m-px']*1.5
        
        pos1 =  ( VBase3(pos1[0]+cos(betaRadians)*desplaz_carril , pos1[1]+sin(betaRadians)*desplaz_carril,0) )
        """
        pos1.addX(cos(betaRadians)*3.2)
        pos1.addY(sin(betaRadians)*3.2)
        """
        
        #desplazamiento desde pos2
        #alpha = anguloDegrees + 90
        #omegaRadians = radians(alpha)
        #pos2 =  ( (pos2[0]+cos(omegaRadians)*3.2 , pos2[1]+sin(omegaRadians)*3.2) )
        
        pos2 =  ( VBase3(pos2[0]+cos(betaRadians)*desplaz_carril , pos2[1]+sin(betaRadians)*desplaz_carril,0) )
        """
        pos2.addX(cos(betaRadians)*3.2)
        pos2.addY(sin(betaRadians)*3.2)
        """
        return (pos1,pos2)
    
    def Movimiento(self,task):
    
        
        # calcula el tiempo entre dos ejecuciones de esta funcion
        
        dt = task.time - task.last
        task.last = task.time
        
        for i in self.vehiculos:
            
            pos_jugador = self.vehiculos[0].getPos()
            pos_vehiculo = self.vehiculos[i].getPos()
            distancia = (pos_vehiculo - pos_jugador).length()
            if distancia <= base.camLens.getFar()*2:
                self.vehiculos[i].Avanzar(dt)
                #self.vehiculos[i].Orientar(None)
            # rehubicacion de la circulacion
            else:
                self.RehubicarVehiculo(i)
                
            
        self.ActualizarCamara()
        
#        # VELOCIDAD
#        self.texto_velocidad.setText('Velocidad: ' + str( str(self.jugador.velocidad/Escalas['kmh-pxs']).partition('.')[0] ) )
        
        
#        SUSTITUIDO POR EL EVENTO SET RUMBO CALCULAR EL PROXIMO DESTINO
#        
#        
#        
#        if self.jugador.HaLlegado() and (not self.jugador.EstaParado()):
#            
#            nodo_sig_destino = self.CalcularNodoDestino( self.jugador.getNodoDestino(),
#                                                         self.jugador.getNodoSigDestino(),
#                                                         True )
#            
#            self.jugador.lista_sg = nodo_sig_destino
#            # actualiza el numero de destinos disponibles
#            self.jugador.num__nsd = 0
#            
#            total = str(self.jugador.lista_sg.__len__())
#            n = str(self.jugador.num__nsd+1)
#            self.texto_destinos.node().setText('Pulse \'d\' para cambiar el destino. Total: ' + total + ', actual: ' + n) 
#            
#            # establece destino del siguiente salto
#            # actualiza el nodo_origen y nodo_sig_destino
#            self.jugador.setNodoSigDestino( nodo_sig_destino[0] )
#            
#            # existe un destino inmediato
#            if self.jugador.getNodoOrigen() != self.jugador.getNodoDestino():
#            
#                # hay un tercer destino, cruce de carriles
#                if self.jugador.getNodoDestino() != self.jugador.getNodoSigDestino():
#                                        
#                # origen destino y sig_destino son diferentes
#                    
#                    # la posicion de destino sera el cruce de carriles
#                    pos1 = self.mapa.getNodoPosById( self.jugador.getNodoOrigen() )
#                    pos2 = self.mapa.getNodoPosById( self.jugador.getNodoDestino() )
#                    pos3 = self.mapa.getNodoPosById( self.jugador.getNodoSigDestino() )
#                    
#                    # establece como posicion de destino el cruce de carriles
#                    cruce = self.CalcularCruceCarriles(pos1, pos2, pos3)
#                    self.jugador.setPosDestino(cruce)
#                    """ sustituida por  el evento Orientar
#                    self.jugador.CalcularHeading()
#                    """
#                    # FLECHA
#                    """
#                    direccion = self.CalcularPosicionesCarriles(pos2,pos3)
#                    self.flecha.CalcularHeading(cruce,direccion[1])
#                    self.flecha.setPos(cruce)
#                    """
#                    self.flecha.setPos(cruce)
#                    self.flecha.setDestino( self.CalcularPosicionesCarriles(pos2,pos3)[1] )
#                    self.flecha.Orientar()
#                    
#                    # FLECHA MINI
#                    self.flecha_mini.CalcularHeading(pos1, pos2, pos3)
#                    
#                    """
#                    self.brujula.setRoll(self.jugador.getHeading())
#                    """
#                    
#                    self.jugador.Avanzar(dt)
#                    self.ActualizarCamara()
#                    
#                    
#                # no hay tercer destino, final del carril
#                else:
#                    # calcula la posicion de destino como al final del carril
#                    pos1 = self.mapa.getNodoPosById( self.jugador.getNodoOrigen() )
#                    pos2 = self.mapa.getNodoPosById( self.jugador.getNodoDestino() )
#                    # pos es una tupla con el inicio y final del carril
#                    pos = self.CalcularPosicionesCarriles(pos1, pos2)
#                    
#                    # la posicion de destino es el final del carril
#                    self.jugador.setPosDestino(pos[1])
#                    self.jugador.CalcularHeading()
#                
#                    self.jugador.Avanzar(dt)  
#                    self.ActualizarCamara()
#                    
#            # no hay un destino inmediato
#            else:
#                self.jugador.Parar()
#                
#        
#                      
#        else:
#            self.jugador.Avanzar(dt)
#            #print 'Ciculacion:Movimiento', 'pos jugador', self.jugador.getPos()
#            self.ActualizarCamara()
        
#            
#        # CONTROL DEL RESTO DE VEHICULOS
#        i = 1
#        # recorriendo la lista de vehiculos
#        while i < (self.vehiculos.__len__()):
#             
#            
#            # si le vehiculo a llegado a su destino
#            if (self.vehiculos[i].HaLlegado() and (not self.vehiculos[i].EstaParado()) ):
#                
#                # determina el nodo de destino inmediato
#                #nodo_destino = self.CalcularNodoDestino(v.getNodoOrigen())
#                # calcula el nodo del siguiente salto
#                nodo_sig_destino = self.CalcularNodoDestino( self.vehiculos[i].getNodoDestino(),
#                                                             self.vehiculos[i].getNodoSigDestino() )
#                
#                # establece destino del siguiente salto
#                # actualiza el nodo_origen y nodo_sig_destino
#                self.vehiculos[i].setNodoSigDestino( nodo_sig_destino )
#                
#                # existe un destino inmediato
#                if self.vehiculos[i].getNodoOrigen() != self.vehiculos[i].getNodoDestino():
#                    
#                    # existe un tercer destino, cruce carriles.
#                    if self.vehiculos[i].getNodoDestino() != self.vehiculos[i].getNodoSigDestino():
#                        
#                        # la posicion de destino sera el cruce de carriles
#                        pos1 = self.mapa.getNodoPosById( self.vehiculos[i].getNodoOrigen() )
#                        pos2 = self.mapa.getNodoPosById( self.vehiculos[i].getNodoDestino() )
#                        pos3 = self.mapa.getNodoPosById( self.vehiculos[i].getNodoSigDestino() )
#                        
#                        # calcula la posicion de partida del vehiculo
#                        pos = self.CalcularPosicionesCarriles(pos1, pos2)
#                        
#                        # establece como posicion de destino el cruce de carriles
#                        pos = self.CalcularCruceCarriles(pos1, pos2, pos3)
#                        self.vehiculos[i].setPosDestino(pos)
#                        self.vehiculos[i].CalcularHeading()                              
#                        
#                        self.vehiculos[i].Avanzar(dt)
#            
#                    # no hay tercer destino, final de carril
#                    else:
#                        
#                        # calcula la posicion de destino como al final del carril
#                        pos1 = self.mapa.getNodoPosById( self.vehiculos[i].getNodoOrigen() )
#                        pos2 = self.mapa.getNodoPosById( self.vehiculos[i].getNodoDestino() )
#                        # pos es una tupla con el inicio y final del carril
#                        pos = self.CalcularPosicionesCarriles(pos1, pos2)
#                        
#                        # la posicion de destino es el final del carril
#                        self.vehiculos[i].setPosDestino(pos[1])
#                        self.vehiculos[i].CalcularHeading()
#                    
#                        self.vehiculos[i].Avanzar(dt)
#            
#                # no hay destino inmediato, eliminar
#                else:
#                    self.vehiculos[i].hide()
#                    self.vehiculos[i].Parar()
#                    #self.vehiculos.pop(i)
#                    
#            # no ha llegado a su destino, continuar avanzando        
#            else:
#                # el vehiculo no ha llegado a su destino
#                self.vehiculos[i].Avanzar(dt)
#                    
#            i = i+1
#        #fin de while
              
        # para que se siga ejecutando
        return Task.cont
    
    # realiza la misma funcion que movimiento control por eventos(NO TASK) 
    def setRumbo(self,entry):

        # identifica al vehiculo que ha llegado a su destino
#        i = int( entry.getFromNodePath().getName() )
        i = int( entry.getIntoNodePath().getName().split('_')[-1] )
        # VEHICULO DEL JUGADOR
        if i == 0:
            if not self.jugador.EstaParado():
                
                # ejecuta la inversion del rumbo si fue activada
                if self.invRumbo:
                    self.InvertirRumbo()
                    return 0
                
                
                nodo_sig_destino = self.CalcularNodoDestino( self.jugador.getNodoDestino(),
                                                             self.jugador.getNodoSigDestino(),
                                                             True)
                
                self.jugador.lista_sg = nodo_sig_destino
                # actualiza el numero de destinos disponibles
                self.jugador.num__nsd = 0
                
                total = str(self.jugador.lista_sg.__len__())
                n = str(self.jugador.num__nsd+1)
                self.texto_destinos.node().setText('Pulse \'d\' para cambiar el destino. Total: ' + total + ', actual: ' + n) 
                
                # establece destino del siguiente salto
                # actualiza el nodo_origen y nodo_sig_destino
                self.jugador.setNodoSigDestino( nodo_sig_destino[0] )
                
                # INSTRUCCIONES DE DIRECCION
                self.direccion_actual.node().setText('Posición actual: '+ self.mapa.getWayNombreByNodo( self.jugador.getNodoOrigen() ))
                self.direccion_siguiente.node().setText('Destino inmediato: '+ self.mapa.getWayNombreByNodo( self.jugador.getNodoDestino() ))        
                self.direccion_siguiente_salto.node().setText('Siguiente destino: '+ self.mapa.getWayNombreByNodo( self.jugador.getNodoSigDestino() ))
                
                # existe un destino inmediato
                if self.jugador.getNodoOrigen() != self.jugador.getNodoDestino():
                
                    # hay un tercer destino, cruce de carriles
                    if self.jugador.getNodoDestino() != self.jugador.getNodoSigDestino():
                                            
                    # origen destino y sig_destino son diferentes
                        

                        # la posicion de destino sera el cruce de carriles
                        pos1 = self.mapa.getNodoPosById( self.jugador.getNodoOrigen() )
                        pos2 = self.mapa.getNodoPosById( self.jugador.getNodoDestino() )
                        pos3 = self.mapa.getNodoPosById( self.jugador.getNodoSigDestino() )
                        
#                        # si en ese nodo solo hay camino unico la carretera esta en el centro
#                        if self.mapa.getOneWayByNodo(self.jugador.getNodoDestino()) == 'yes':
#                            cruce = pos2
#                        else:
#                            # establece como posicion de destino el cruce de carriles
#                            cruce = self.CalcularCruceCarriles(pos1, pos2, pos3)
                            
                        cruce = self.CalcularCruceCarrilesNodos(self.jugador.getNodoOrigen(),
                                                         self.jugador.getNodoDestino(), 
                                                         self.jugador.getNodoSigDestino())

                        self.jugador.setPosDestino(cruce)
                        
                        # FLECHA
                        self.flecha.setPos(pos2)
#                        self.flecha.setDestino( self.mapa.getNodoPosById( self.jugador.getNodoSigDestino() ))
                        self.flecha.setDestino(pos3)
                        self.flecha.Orientar()
                        

                        # FLECHA MINI
                        self.flecha_mini.CalcularHeading(pos1, pos2, pos3)

                        
    #                    BRUJULA ELIMINADA DEL ESCENARIO
    #                    self.brujula.setRoll(self.jugador.getHeading())
                        
                        self.jugador.Orientar()
                        
                        
                    # no hay tercer destino, final del carril
                    else:
                        # calcula la posicion de destino como al final del carril
                        pos1 = self.mapa.getNodoPosById( self.jugador.getNodoOrigen() )
                        pos2 = self.mapa.getNodoPosById( self.jugador.getNodoDestino() )
                        # pos es una tupla con el inicio y final del carril
                        
                        # si en ese nodo solo hay camino unico la carretera esta en el centro
                        if self.mapa.getOneWayByNodo(self.jugador.getNodoDestino()) == 'yes':
                            pos = pos2
                        else:
                            # establece como posicion de destino el cruce de carriles
                            pos = self.CalcularPosicionesCarriles(pos1, pos2)[1]
                        
                        # la posicion de destino es el final del carril
                        self.jugador.setPosDestino(pos)
    #                    sustituida por  el evento Orientar
    #                    self.jugador.CalcularHeading()
                        self.jugador.Orientar()
                    
    #                    self.jugador.Avanzar(dt)  
                        self.ActualizarCamara()
                        
                # no hay un destino inmediato
                else:
                    self.NotificarLimiteMapa(None)
                          
#            else:
#    #            self.jugador.Avanzar(dt)
#                #print 'Ciculacion:Movimiento', 'pos jugador', self.jugador.getPos()
#                self.ActualizarCamara()
    
        # RESTO DE VEHICULOS
        else:
             # si le vehiculo a llegado a su destino
            if not self.vehiculos[i].EstaParado() :
                
                # determina el nodo de destino inmediato
                #nodo_destino = self.CalcularNodoDestino(v.getNodoOrigen())
                # calcula el nodo del siguiente salto
                nodo_sig_destino = self.CalcularNodoDestino( self.vehiculos[i].getNodoDestino(),
                                                             self.vehiculos[i].getNodoSigDestino() )
                
                # establece destino del siguiente salto
                # actualiza el nodo_origen y nodo_sig_destino
                self.vehiculos[i].setNodoSigDestino( nodo_sig_destino )
                
                # existe un destino inmediato
                if self.vehiculos[i].getNodoOrigen() != self.vehiculos[i].getNodoDestino():
                    
                    # existe un tercer destino, cruce carriles.
                    if self.vehiculos[i].getNodoDestino() != self.vehiculos[i].getNodoSigDestino():
                        
                        # la posicion de destino sera el cruce de carriles
#                        pos1 = self.mapa.getNodoPosById( self.vehiculos[i].getNodoOrigen() )
#                        pos2 = self.mapa.getNodoPosById( self.vehiculos[i].getNodoDestino() )
#                        pos3 = self.mapa.getNodoPosById( self.vehiculos[i].getNodoSigDestino() )
#                        
                        cruce = self.CalcularCruceCarrilesNodos(self.vehiculos[i].getNodoOrigen(),
                                                         self.vehiculos[i].getNodoDestino(), 
                                                         self.vehiculos[i].getNodoSigDestino())
                        
                        self.vehiculos[i].setPosDestino(cruce)
    #                    sustituida por  el evento Orientar
    #                    self.vehiculos[i].CalcularHeading()
                        self.vehiculos[i].Orientar()
#                        self.vehiculos[i].Avanzar(dt)
            
                    # no hay tercer destino, final de carril
                    else:
                        
                        # calcula la posicion de destino como al final del carril
                        pos1 = self.mapa.getNodoPosById( self.vehiculos[i].getNodoOrigen() )
                        pos2 = self.mapa.getNodoPosById( self.vehiculos[i].getNodoDestino() )
                        
                        if self.mapa.getOneWayByNodo(self.vehiculos[i].getNodoDestino()) == 'yes':
                            pos = pos2
                        else:
                            # establece como posicion de destino el cruce de carriles
                            pos = self.CalcularPosicionesCarriles(pos1, pos2)[1]
                        
                        # la posicion de destino es el final del carril
                        self.vehiculos[i].setPosDestino(pos)
    #                    sustituida por  el evento Orientar
    #                    self.vehiculos[i].CalcularHeading()
                        self.vehiculos[i].Orientar()
#                        self.vehiculos[i].Avanzar(dt)
            
                # no hay destino inmediato, eliminar
                else:
                    self.RehubicarVehiculo(i)
#                    self.vehiculos[i].hide()
#                    self.vehiculos[i].Parar()
                    #self.vehiculos.pop(i)
                    
#            # no ha llegado a su destino, continuar avanzando        
#            else:
#                # el vehiculo no ha llegado a su destino
#                pass
##                self.vehiculos[i].Avanzar(dt)
        
    
    def InvertirRumbo(self):
        
        print 'Circulacion:InvertirRumbo'
        
        nodo_destino = self.jugador.getNodoDestino()
        nodo_origen = self.jugador.getNodoOrigen()
        
        pos = self.CalcularPosicionesCarriles(self.mapa.getNodoPosById(nodo_destino),
                                              self.mapa.getNodoPosById(nodo_origen))
        
        # establece como destino desplazar el vehiculo al carril contrario
        self.jugador.setPosDestino(pos[0])
        
        nuevo_origen = self.jugador.getNodoSigDestino()
        nuevo_destino = self.jugador.getNodoDestino() 
        nuevo_sig_destino = self.jugador.getNodoOrigen() 
        
        self.jugador.setNodoSigDestino(nuevo_origen)
        self.jugador.setNodoSigDestino(nuevo_destino)
        self.jugador.setNodoSigDestino(nuevo_sig_destino)
        
        self.jugador.Orientar()
        
        self.invRumbo = False
            
    def ActivarInvertirRumbo(self):
        
        print 'Circulacion:ActivarInvertirRumbo'

        # solo se pueden cambiar invertir el rumbp en calles de doble sentido
        nodo_destino = self.jugador.getNodoOrigen()
        if self.mapa.getOneWayByNodo(nodo_destino) == 'no':
            if not self.invRumbo:
                self.invRumbo = True
            
                self.flecha.setDestino(self.mapa.getNodoPosById(self.jugador.getNodoOrigen()))
                self.flecha.Orientar()

                # FLECHA MINI
                self.flecha_mini.setRoll(180)
                
                
            else:
                
                self.invRumbo = False
            
                self.flecha.setDestino(self.mapa.getNodoPosById(self.jugador.getNodoSigDestino()))
                self.flecha.Orientar()
                
                # la posicion de destino sera el cruce de carriles
                pos1 = self.mapa.getNodoPosById( self.jugador.getNodoOrigen() )
                pos2 = self.mapa.getNodoPosById( self.jugador.getNodoDestino() )
                pos3 = self.mapa.getNodoPosById( self.jugador.getNodoSigDestino() )
                
                # FLECHA MINI
                self.flecha_mini.CalcularHeading(pos1, pos2, pos3)
    
            
    def ActualizarCamara(self):

        # control de la posicion de la camara
        camvec = self.jugador.coche.getPos() - base.camera.getPos()
        camvec.setZ(0)
        camdist = camvec.length()
        camvec.normalize()
        dist = Escalas['m-px']*10
        if (camdist > Escalas['m-px']*dist):
            base.camera.setPos(base.camera.getPos() + camvec*(camdist-dist))
            camdist = Escalas['m-px']*dist
        elif (camdist < Escalas['m-px']*dist):
            base.camera.setPos(base.camera.getPos() - camvec*(dist-camdist))
            camdist = Escalas['m-px']*dist

        base.camera.lookAt(self.jugador.coche)
        base.camera.setP(base.camera.getP()+10)
    
    def getNodoOrigenJugador(self):
        return self.jugador.getNodoOrigen()
    
    def getNodoDestinoJugador(self):
        return self.jugador.getNodoDestino()
            
    def getPosJugador(self):
        return self.jugador.getPos()  
    
    def getHeadingJugador(self):
        return self.jugador.getHeading()  
    
    # devuelve el nombre del nodo from del vehiculo del jugador
    def getcNodePathNameJugador(self):
        return self.jugador.getcNodePathNameFrom()
    
    def AumentarVelocidad(self):
        for v in self.vehiculos:
            self.vehiculos[v].setVelMax( self.velocidades_aumentar[self.vehiculos[v].getVelMax()] )
        
        self.texto_velocidad.setText('Velocidad máxima: ' + str(self.jugador.getVelMax()/Escalas['kmh-pxs']).split('.')[0])
      
    def DisminuirVelocidad(self):
        for v in self.vehiculos:
            self.vehiculos[v].setVelMax( self.velocidades_disminuir[self.vehiculos[v].getVelMax()] )
        
        self.texto_velocidad.setText('Velocidad máxima: ' + str(self.jugador.getVelMax()/Escalas['kmh-pxs']).split('.')[0])
        
    def __del__(self):
        self.NodoCirculacion.removeNode()
        self.NodoCirculacion2d.removeNode()
        
        
"""
    # establece el valor de la variable de la tecla pulsada
    def setKey(self,bt,valor):
        
        self.keyMap[bt] = valor
        
    # segun los valores de keyMap realiza el movimiento
 
    def Movimiento(self,task):
        
        # calcula el tiempo entre dos ejecuciones de esta funcion
        elapsed = task.time - self.last
        
        #movimiento de orientacion de la camara
        # figure out how much the mouse has moved (in pixels)
        md = base.win.getPointer(0)
        x = md.getX()
        y = md.getY()
        if base.win.movePointer(0, 100, 100):
            self.heading = self.heading - (x - 100)*0.2
            self.pitch = self.pitch - (y - 100)*0.2
        if (self.pitch < -89): self.pitch = -89
        if (self.pitch >  89): self.pitch =  89
        base.camera.setHpr(self.heading,self.pitch,0)
        dir = base.camera.getMat().getRow3(1)
        elapsed = task.time - self.last
        if (self.last == 0): elapsed = 0
        if (self.keyMap["w"]):
            self.focus = self.focus + dir * elapsed*30
        if (self.keyMap["s"]):
            self.focus = self.focus - dir * elapsed*30
        base.camera.setPos(self.focus - (dir*5))
        
        
        
        # guarda el instante de tiempo en que termina la ejecucion
        self.last = task.time
        # para que se siga ejecutando en la proxima iteracion
        return Task.cont
        
"""